module TortoiseLabs
  class Client
    
    def self.base_uri
      @base_uri ||= "https://manage.tortois.es"
    end
    
    def self.base_uri=(value)
      @base_uri = value.to_s.chomp("/")
    end
    
    def self.username=(value)
      @username = value
    end
    
    def self.password=(value)
      @password = value
    end
    
    def self.auth_options
      if @username.nil? or @password.nil?
        raise NotAuthenticated
      end
      
      {:basic_auth => {:username => @username, :password => @password}}
    end
    
    def self.get(path, options = {})
      HTTParty.get(base_uri + path, options.merge(auth_options))
    end
    
    def self.post(path, options)
      options = {:body => options}.merge(auth_options)
      HTTParty.post(base_uri + path, options)
    end
  end
end